#ifndef _QSCALE_H_
#   define _QSCALE_H_

#include <qmainwindow.h>

class QTag;

class QScale : public QMainWindow
{
   Q_OBJECT

   public:
      QScale(
         QTag *theTag,
         QWidget *parent  = 0,
         const char *name = 0,
         WFlags f         = WType_TopLevel
      );

      ~QScale();

      void handlePaintEvent(QWidget *target, QPaintEvent *e);
      void handleResizeEvent(QWidget *target, QResizeEvent *e);

   private slots:
      void slotQuit();
      void slotKey(int which);
      void slotScale(int which);
      void slotTimerFinished();
      void slotPrint();
      void slotKeyIncrement();
      void slotKeyDecrement();
      void slotScaleIncrement();
      void slotScaleDecrement();
      void slotSharpsFlats();

   private:
      void drawFretBoard(QPainter *p, int width, int height);

   private:
      QScale(const QScale &);
      QScale &operator=(const QScale &);

      struct Internal;
      Internal *mInternal;
};

#endif
