#ifndef _QTAG_H_
#   define _QTAG_H_

#include <qvaluelist.h>

class QString;
typedef QValueList<QString> AttributeKeyList;

class QTagVisitor;

class QTag
{
   public:
      QTag(const QString &tagName);
      ~QTag();

      static QTag *read(const QString &fileName, QString &errMsg);
      static QTag *readFromText(const QString &text, QString &errMsg);

      bool write(const QString &fileName, QString &errMsg) const;
      void writeToStdout() const;

      void accept(QTagVisitor &visitor) const;

      const QString &getAttribute(const QString &key) const;
      bool addAttribute(const QString &key, const QString &value);
      bool removeAttribute(const QString &key);
      void getKeys(AttributeKeyList &theList) const;

      int getChildCount() const;
      QTag *getChild(int index) const;
      void addChild(QTag *child);
      bool removeChild(int index);
      QTag *takeChild(int index);

      const QString &name() const;

      static int main(int argc, char **argv);

   private:
      QTag(const QTag &);
      QTag& operator=(const QTag &);

      struct Internal;
      friend struct Internal;
      Internal *mInternal;
};

#endif
